Subject: Re: [PATCH 2/3] t5304: use helper to report failure of "test foo = bar"

From: Jonathan Nieder <[email-masked]>
Date: Mon, 13 Oct 2014 14:31:32 -0700

Jeff King wrote:
> On Mon, Oct 13, 2014 at 09:10:22AM -0700, Jonathan Nieder wrote:

>> There's another downside to that construct: it loses the exit
>> status from some_cmd.
>
> Yes, although I think in many cases it's not a big deal. For example,
> here we lose the exit code of count-objects, but it also is very
> unlikely to fail _and_ produce our expected output.

It could segfault after producing the good output, but sure,
count-objects code doesn't change very often.

[...]
> One of my goals was to provide a more generic helper so that we don't
> have to make little helpers like this for every command. So I'd much
> rather something like:
>
>   test_output () {
> 	printf "%s\n" "$1" >expect &&
> 	shift &&
> 	"$@" >output &&
> 	test_cmp expect output
>   }

I agree with the principle in general.

Unfortunately that wouldn't help here --- the "$@" is a command with a
pipe to sed in it and we still lose the exit status from
count-objects.

Hoping that clarifies,
Jonathan